<template>
  <div class="form-wrapper">
    <h2
      v-if="title && content.title"
      v-html="content.title"
    ></h2>

    <template
      v-for="element in content.elements"
      :key="element.index"
    >
      <div
        class="input-wrapper"
        v-if="element.code === 'name'"
      >
        <Input
          v-model="name"
          :placeholder="element.placeholder"
          :hint="element.title"
          :input-type="element.code"
          :is-error="checkValidationForm"
        />
      </div>
      <div
        class="input-wrapper"
        v-if="element.code === 'company'"
      >
        <Input
          v-model="company"
          :placeholder="element.placeholder"
          :hint="element.title"
          :input-type="element.code"
        />
      </div>
      <div
        class="input-wrapper"
        v-if="element.code === 'phone'"
      >
        <Input
          v-model="tel"
          :placeholder="element.placeholder"
          :hint="element.title"
          :input-type="element.code"
          :model-value="tel"
          :is-error="checkValidationForm"
        />
      </div>
      <div
        class="input-wrapper"
        v-if="element.code === 'email'"
      >
        <Input
          v-model="email"
          :placeholder="element.placeholder"
          :hint="element.title"
          :input-type="element.code"
        />
      </div>
      <div
        class="input-wrapper"
        v-if="element.code === 'type_product'"
      >
        <Select
          v-model="typeProduct"
          :options="element.options"
          :placeholder="element.placeholder"
          :hint="element.title"
        />
      </div>
      <div
        class="input-textarea-wrapper"
        v-if="element.code === 'message_text' || element.code === 'message'"
      >
        <Input
          v-model="comment"
          :placeholder="element.placeholder"
          :hint="element.title"
          :textarea="textarea"
        />
      </div>
      <div
        class="btn-form"
        v-if="element.code === 'btn_send'"
      >
        <Button
          :size="btnSize"
          color="blue"
          :disabled="checkValidationForm"
          @click="sendData"
        >
          <slot>{{ element.title }}</slot>
        </Button>
      </div>
      <div
        v-if="isPopup"
        class="popup-form-wrapper"
        @click.self="clousePopup"
      >
        <div
          class="popup-form"
          v-if="popupContent"
        >
          <!-- <check /> -->
          <img
            :src="popupContent.image"
            alt=""
          />
          <p v-html="popupContent.text"></p>
          <Button
            :size="'medium'"
            color="blue"
            @click="clousePopup"
          >
            <slot>{{ popupContent.btn_text }}</slot>
          </Button>
        </div>
      </div>
    </template>
    <preloader v-if="isLoad"></preloader>
  </div>
</template>

<script>
import { HTTP, Routes } from '../api/API';
import Button from './common/button.vue';
import Input from './common/input.vue';
import Preloader from './common/preloader.vue';
import Select from './common/select.vue';
import Check from './icons/check.vue';
import { noScroll } from '../main';

export default {
  components: { Input, Button, Select, Check, Preloader },
  props: {
    textarea: { type: Boolean, default: true },
    btnSize: { type: String },
    options: { type: Array },
    typeFeed: { type: Boolean, default: true },
    title: { type: Boolean, default: true },
    content: { type: Object },
    messages: { type: Array },
    isMenuForm: { type: Boolean, default: false },
    isContactsForm: { type: Boolean, default: false },
    page_url: { type: String, default: '' },
  },
  data() {
    return {
      comment: '',
      email: '',
      tel: '',
      name: '',
      company: '',
      typeProduct: {},
      dataForm: {},
      isDisabled: true,
      isPopup: false,
      nameObj: {},
      companyObj: {},
      phoneObj: {},
      emailObj: {},
      type_productObj: {},
      messageObj: {},
      btn_sendObj: {},
      isSendData: false,
      popupContent: null,
      isLoad: false,
    };
  },
  computed: {
    checkValidationForm() {
      if (this.name && this.tel.length == 18) {
        this.isDisabled = false;
      }
      return this.isDisabled;
    },
  },
  created() {},
  mounted() {},
  updated() {},
  methods: {
    sendData() {
      if (!this.isDisabled) {
        this.dataForm = {
          name: this.name,
          phone: this.tel,
          email: this.email,
          company: this.company,
          message: this.comment,
          type_product: this.typeProduct.value,
          page_url: this.$route.path,
          is_popup: this.isMenuForm ? 'Y' : 'N',
          is_connect_with_us: this.isContactsForm ? 'Y' : 'N',
        };
      }
      this.isLoad = true;
      HTTP.post(Routes.postForm, this.dataForm)
        .then(data => {
          if (data.data.data.error) {
            this.messages.forEach(item => {
              if (item.code === 'result_error') {
                this.popupContent = item;
              }
            });
            this.isLoad = false;
            this.isPopup = true;
          }
          if (data.data.data.result) {
            this.messages.forEach(item => {
              if (item.code === 'result_ok') {
                this.popupContent = item;
              }
            });
            this.isLoad = false;
            this.isPopup = true;
            this.isDisabled = true;

            //vk pixel
            var _tmr = window._tmr || (window._tmr = []);
            _tmr.push({ type: 'reachGoal', id: 3537089, goal: 'Lead'});

            //обнуляем данные формы
            this.name = '';
            this.tel = '';
            this.email = '';
            this.company = '';
            this.comment = '';
            this.typeProduct = {};
          }
          noScroll(this.isPopup);
        })
        .catch(e => {
          console.error(e);
        });
    },
    clousePopup() {
      this.isPopup = false;
      noScroll(this.isPopup);
      // this.$emit("update:openPopup", this.isPopup);
    },
  },
};
</script>
